package com.totopia.server.modules.game.service;

import com.totopia.server.commons.exception.ResourceNotFoundException;
import com.totopia.server.modules.game.entity.SportsEntity;
import com.totopia.server.modules.game.repository.SportsRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

@Service
public class SportsService {

  @Autowired
  private SportsRepository sportsRepository;

  public Page<SportsEntity> getAllSportsByPageable(Pageable pageable) {
    Page<SportsEntity> entities = null;
    entities = this.sportsRepository.findAll(pageable);
    return entities;
  }

  public SportsEntity getSportsById(Short sportId) {
    return this.sportsRepository.findById(sportId).orElseThrow(null);
  }

  public SportsEntity save(SportsEntity sportsEntity) {
    return this.sportsRepository.save(sportsEntity);
  }

  public SportsEntity modify(SportsEntity sportsEntity) {
    return this.sportsRepository.save(sportsEntity);
  }

  public Short remove(Short sportsId) {
    return sportsRepository.findById(sportsId).map(sports -> {
      sportsRepository.delete(sports);
      return sportsId;
    }).orElseThrow(() -> new ResourceNotFoundException("Sports", "sportsId", sportsId));
  }
}
